; Lightbox 512b for MS-DOS
; October 2014
; HellMood : 512b -> 427b

fval equ 8+64
temp equ 12+64
t equ 20+64
tx equ 24+64
dila equ 25+64

org 100h

;half dd 0.5
half equ 0x0100 - 3
db 0x3F		; = AAS , harmless command

;mov ax, 13h
mov al, 13h
int 10h

;xor cx, cx
palloop:
  mov dx, 0x3c8
  mov al, cl
  out dx, al
  inc dx
  shr al, 2
  out dx, al
  out dx, al
  out dx, al
;dec cl
loop palloop


push 0a000h
pop es

sub sp, 48

render:

  mov bp, sp
  ;fld dword [fval]
  fld dword [bx+fval]
  fadd dword [finc]
  ;fst dword [fval]
  fst dword [bx+fval]
  fsincos
  fst dword [bp+4]
  fst dword [bp+20]
  fstp dword [bp+44]
  fst dword [bp+12]
  fst dword [bp+28]
  fstp dword [bp+36]

  ;xor cx, cx
  ;mov cx,200
  mov cl,200
  yloop:

    ;xor dx, dx
	mov dx,320
    xloop:

      mov bp, sp

      ;mov word [temp], cx
      ;fild word [temp]
      mov word [bx], cx
      fild word [bx]
      fadd st0
      fild word [height]
      fdivr st1
      fld1
      fsubrp
      fst dword [bp+16]
      fstp dword [bp+32]

      ; mov word [temp], dx
      ; fild word [temp]
      mov word [bx], dx
      fild word [bx]
      fadd st0
      fild word [width]
      fdivr st1
      fld1
      fsubp
      fst dword [bp]

      fmul dword [bp+12]
      fld dword [half]
      fmul dword [bp+4]
      faddp
      fst dword [bp+40]
      fchs
      fstp dword [bp+24]

      fld dword [half]
      fchs
      fstp dword [bp+8]

      fild word [width]
      fmul st0
      ;fstp dword [t]
      fstp dword [bx+t]

      fninit
      fld dword [ten]

      ;xor si,si
	  mov si, 2
      outer:
        mov bp, sp
        ;xor di, di
		mov di,3
        inner:

          fld dword [bp] ; a | 10
          fmul dword [bp+4] ; a*b | 10
          fld dword [bp+8] ; c | a*b | 10
          fmul dword [bp+12] ; c*d | a*b | 10
          faddp ; c*d+a*b | 10
          add bp, 16

          fdivr st1
          ;fstp dword [tx]
          fstp dword [bx+tx]
          
		  ;cmp dword [tx], 0
		  ;cmp dword [tx], ebx ; assumed ebx = 0
		  cmp dword [bx+tx], ebx ; assumed ebx = 0
		  		  
          jge first
            ;fld dword [t]
            fld dword [bx+t]
			;fstp dword [tx]
			fstp dword [bx+tx]
          first:
          ;mov eax, dword [tx]
          mov eax, dword [bx+tx]
          ;cmp eax, dword [t]
          cmp eax, dword [bx+t]
		  
          
		  jge second
            ;mov dword [t], eax
            mov dword [bx+t], eax
          second:

        ;inc di
        ;cmp di, 3
        ;jne inner
		dec di
		jnz inner

        fchs

      ;inc si
      ;cmp si, 2
      ;jne outer
	  dec si
	  jnz outer

      ;fld dword [t]
      fld dword [bx+t]
	  
      fdiv dword [ten]
      fld st0
      fmul st0
      fmulp st1
      fld1
      faddp
      fld1
      fdivrp st1
      ;fstp dword [tx]
      fstp dword [bx+tx]

      fninit
      fild word [eight]

      mov bp, sp
      ;xor di, di
	  mov di,12
      lights:
        ; mov word [temp], di
        ; fild word [temp]
        mov word [bx], di
        fild word [bx]
        fldpi
        fadd st0
        fmulp st1
        ; mov word [temp], 12
        ; fild word [temp]
        mov word [bx], 12
        fild word [bx]
        fdivp st1
        ;fld dword [fval]
        fld dword [bx+fval]
        fchs
        fadd st0
        fadd st0
        faddp st1
        fsincos ; cos | sin | s

        fld dword [bp] ; x | cos | sin | s
        ;fmul dword [t]
        fmul dword [bx+t]
        fld st2 ; sin | x | cos | sin | s
        fmul st4
        fsubp st1 ; sin-x | cos | sin | s
        fmul st0

        fld dword [bp+16] ; y | sin-x | cos | sin | s
        ;fmul dword [t]
        fmul dword [bx+t]
        fld st2 ; cos | y | sin-x | cos | sin | s
        fmul st5
        fsubp st1 ; cos-y | sin-x | cos | sin | s
        fmul st0
        faddp st1 ; cos+sin | cos | sin | s

        fld dword [bp+40] ; z | cos+sin | cos | sin | s
        fdiv dword [half]
        ;fmul dword [t]
        fmul dword [bx+t]
        fsub st4 ; z-s | cos+sin | cos | sin | s
        fmul st0
        faddp st1 ; x+y+z | cos | sin | s

        fld1
        faddp st1 ; 1+x+y+z | cos | sin | s
        fld1
        fdivrp st1 ; 1/(1+x+y+z) | cos | sin | s

        ;fadd dword [tx]
        fadd dword [bx+tx]
        ;fstp dword [tx]
        fstp dword [bx+tx]
        ;fstp dword [temp]
        ;fstp dword [temp]
        fstp dword [bx]
        fstp dword [bx]
        fchs
      ;inc di
      ;cmp di, 12
      ;jne lights
	  dec di
	  jnz lights
		
      fld1
      fst dword [bx]
      mov eax, dword [bx]
      ;fst dword [temp]
      ;mov eax, dword [temp]
      ;cmp dword [tx], eax
      cmp dword [bx+tx], eax
      jle saturate
        mov dword [bx+tx], eax
        ;mov dword [tx], eax
      saturate:
      ;fld dword [tx]
      fld dword [bx+tx]

      fmul dword [scale]
      ;fistp word [temp]
      ;mov ax, word [temp]
      fistp word [bx]
      mov ax, word [bx]

      mov di, cx
      imul di, 320
      add di, dx
      ;mov byte [es:di], al
	  stosb		
	
    ; inc dx
    ; cmp dx, 320
    ; jne xloop
	dec dx
	jnz xloop
  ; inc cx
  ; cmp cx, 200
  ; jne yloop
  
  dec cx
  jnz yloop
  ;loop yloop ;would be shorter but out of range ;)

  
mov ah,01h
int 16h
jz render

;add sp, 48 ; not needed with int 0x20
;ret   ; is overwritten by former temp access ;)
int 0x20

finc dd 0.05
width dw 320
height dw 200
ten dd 10.0
eight dw 10
scale dd 255.0

; fval dd 0.0
; temp dd 0.0
; t dd 0.0
; tx dd 0.0
; dila db 0
